"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GlobalStorage = void 0;
const tslib_1 = require("tslib");
const iacry_error_1 = require("../errors/iacry.error");
class GlobalStorage {
    constructor(policies = []) {
        this.policies = policies;
        this.readonly = true;
    }
    fetch(_principal) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            return this.policies;
        });
    }
    fetchBySid(_sid, _principal) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            return [];
        });
    }
    save(_principal, rawPolicies) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            this.policies = [...rawPolicies];
            return rawPolicies.length;
        });
    }
    add(_principal, rawPolicies) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            this.policies = [...this.policies, ...rawPolicies];
            return rawPolicies.length;
        });
    }
    purge(_principal) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const removedCount = this.policies.length;
            this.policies = [];
            return removedCount;
        });
    }
    saveBySid(_sid, _principal, _rawPolicies) {
        throw this.DisallowedException('saveBySid');
    }
    DisallowedException(method) {
        return new iacry_error_1.BaseError(`PolicyInterface Storage method ${method}() invocation not allowed`);
    }
}
exports.GlobalStorage = GlobalStorage;
